gi-pango-1.0.29: Pango bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.Pango.Objects.Layout

Contents

- Exported types
- Methods
  - contextChanged
  - copy
  - deserialize
  - getAlignment
  - getAttributes
  - getAutoDir
  - getBaseline
  - getCaretPos
  - getCharacterCount
  - getContext
  - getCursorPos
  - getDirection
  - getEllipsize
  - getExtents
  - getFontDescription
  - getHeight
  - getIndent
  - getIter
  - getJustify
  - getJustifyLastLine
  - getLine
  - getLineCount
  - getLineReadonly
  - getLineSpacing
  - getLines
  - getLinesReadonly
  - getLogAttrs
  - getLogAttrsReadonly
  - getPixelExtents
  - getPixelSize
  - getSerial
  - getSingleParagraphMode
  - getSize
  - getSpacing
  - getTabs
  - getText
  - getUnknownGlyphsCount
  - getWidth
  - getWrap
  - indexToLineX
  - indexToPos
  - isEllipsized
  - isWrapped
  - moveCursorVisually
  - new
  - serialize
  - setAlignment
  - setAttributes
  - setAutoDir
  - setEllipsize
  - setFontDescription
  - setHeight
  - setIndent
  - setJustify
  - setJustifyLastLine
  - setLineSpacing
  - setMarkup
  - setMarkupWithAccel
  - setSingleParagraphMode
  - setSpacing
  - setTabs
  - setText
  - setWidth
  - setWrap
  - writeToFile
  - xyToIndex

Description

A `PangoLayout` structure represents an entire paragraph of text.

While complete access to the layout capabilities of Pango is provided using the detailed interfaces for itemization and shaping, using that functionality directly involves writing a fairly large amount of code. `PangoLayout` provides a high-level driver for formatting entire paragraphs of text at once. This includes paragraph-level functionality such as line breaking, justification, alignment and ellipsization.

A `PangoLayout` is initialized with a `PangoContext`, UTF-8 string and set of attributes for that string. Once that is done, the set of formatted lines can be extracted from the object, the layout can be rendered, and conversion between logical character positions within the layout's text, and the physical position of the resulting glyphs can be made.

There are a number of parameters to adjust the formatting of a `PangoLayout`. The following image shows adjustable parameters (on the left) and font metrics (on the right):

<picture> <source srcset="layout-dark.png" media="(prefers-color-scheme: dark)"> <img alt="Pango Layout Parameters" src="layout-light.png"> </picture>

The following images demonstrate the effect of alignment and justification on the layout of text:

| | | | --- | --- | | | | | | | | | |

It is possible, as well, to ignore the 2-D setup, and simply treat the results of a `PangoLayout` as a list of lines.

Synopsis

- newtype Layout = Layout (ManagedPtr Layout)
- class (GObject o, IsDescendantOf Layout o) => IsLayout o
- toLayout :: (MonadIO m, IsLayout o) => o -> m Layout
- layoutContextChanged :: (HasCallStack, MonadIO m, IsLayout a) => a -> m ()
- layoutCopy :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Layout
- layoutDeserialize :: (HasCallStack, MonadIO m, IsContext a) => a -> Bytes -> [LayoutDeserializeFlags] -> m (Maybe Layout)
- layoutGetAlignment :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Alignment
- layoutGetAttributes :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Maybe AttrList)
- layoutGetAutoDir :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutGetBaseline :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetCaretPos :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m (Rectangle, Rectangle)
- layoutGetCharacterCount :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetContext :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Context
- layoutGetCursorPos :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m (Rectangle, Rectangle)
- layoutGetDirection :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m Direction
- layoutGetEllipsize :: (HasCallStack, MonadIO m, IsLayout a) => a -> m EllipsizeMode
- layoutGetExtents :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Rectangle, Rectangle)
- layoutGetFontDescription :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Maybe FontDescription)
- layoutGetHeight :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetIndent :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetIter :: (HasCallStack, MonadIO m, IsLayout a) => a -> m LayoutIter
- layoutGetJustify :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutGetJustifyLastLine :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutGetLine :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m (Maybe LayoutLine)
- layoutGetLineCount :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetLineReadonly :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m (Maybe LayoutLine)
- layoutGetLineSpacing :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Float
- layoutGetLines :: (HasCallStack, MonadIO m, IsLayout a) => a -> m [LayoutLine]
- layoutGetLinesReadonly :: (HasCallStack, MonadIO m, IsLayout a) => a -> m [LayoutLine]
- layoutGetLogAttrs :: (HasCallStack, MonadIO m, IsLayout a) => a -> m [LogAttr]
- layoutGetLogAttrsReadonly :: (HasCallStack, MonadIO m, IsLayout a) => a -> m [LogAttr]
- layoutGetPixelExtents :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Rectangle, Rectangle)
- layoutGetPixelSize :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Int32, Int32)
- layoutGetSerial :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Word32
- layoutGetSingleParagraphMode :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutGetSize :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Int32, Int32)
- layoutGetSpacing :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetTabs :: (HasCallStack, MonadIO m, IsLayout a) => a -> m (Maybe TabArray)
- layoutGetText :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Text
- layoutGetUnknownGlyphsCount :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetWidth :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Int32
- layoutGetWrap :: (HasCallStack, MonadIO m, IsLayout a) => a -> m WrapMode
- layoutIndexToLineX :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> Bool -> m (Int32, Int32)
- layoutIndexToPos :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m Rectangle
- layoutIsEllipsized :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutIsWrapped :: (HasCallStack, MonadIO m, IsLayout a) => a -> m Bool
- layoutMoveCursorVisually :: (HasCallStack, MonadIO m, IsLayout a) => a -> Bool -> Int32 -> Int32 -> Int32 -> m (Int32, Int32)
- layoutNew :: (HasCallStack, MonadIO m, IsContext a) => a -> m Layout
- layoutSerialize :: (HasCallStack, MonadIO m, IsLayout a) => a -> [LayoutSerializeFlags] -> m Bytes
- layoutSetAlignment :: (HasCallStack, MonadIO m, IsLayout a) => a -> Alignment -> m ()
- layoutSetAttributes :: (HasCallStack, MonadIO m, IsLayout a) => a -> Maybe AttrList -> m ()
- layoutSetAutoDir :: (HasCallStack, MonadIO m, IsLayout a) => a -> Bool -> m ()
- layoutSetEllipsize :: (HasCallStack, MonadIO m, IsLayout a) => a -> EllipsizeMode -> m ()
- layoutSetFontDescription :: (HasCallStack, MonadIO m, IsLayout a) => a -> Maybe FontDescription -> m ()
- layoutSetHeight :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m ()
- layoutSetIndent :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m ()
- layoutSetJustify :: (HasCallStack, MonadIO m, IsLayout a) => a -> Bool -> m ()
- layoutSetJustifyLastLine :: (HasCallStack, MonadIO m, IsLayout a) => a -> Bool -> m ()
- layoutSetLineSpacing :: (HasCallStack, MonadIO m, IsLayout a) => a -> Float -> m ()
- layoutSetMarkup :: (HasCallStack, MonadIO m, IsLayout a) => a -> Text -> Int32 -> m ()
- layoutSetMarkupWithAccel :: (HasCallStack, MonadIO m, IsLayout a) => a -> Text -> Int32 -> Char -> m Char
- layoutSetSingleParagraphMode :: (HasCallStack, MonadIO m, IsLayout a) => a -> Bool -> m ()
- layoutSetSpacing :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m ()
- layoutSetTabs :: (HasCallStack, MonadIO m, IsLayout a) => a -> Maybe TabArray -> m ()
- layoutSetText :: (HasCallStack, MonadIO m, IsLayout a) => a -> Text -> Int32 -> m ()
- layoutSetWidth :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> m ()
- layoutSetWrap :: (HasCallStack, MonadIO m, IsLayout a) => a -> WrapMode -> m ()
- layoutWriteToFile :: (HasCallStack, MonadIO m, IsLayout a) => a -> [LayoutSerializeFlags] -> [Char] -> m ()
- layoutXyToIndex :: (HasCallStack, MonadIO m, IsLayout a) => a -> Int32 -> Int32 -> m (Bool, Int32, Int32)

# Exported types

newtype Layout Source #

Memory-managed wrapper type.

Constructors

Layout (ManagedPtr Layout) |

#### Instances

Instances details

Eq Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout Methods (==) :: Layout -> Layout -> Bool Source # (/=) :: Layout -> Layout -> Bool Source #
GObject Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout
ManagedPtrNewtype Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout Methods toManagedPtr :: Layout -> ManagedPtr Layout Source #
TypedObject Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout Methods glibType :: IO GType Source #
HasParentTypes Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout
IsGValue (Maybe Layout) Source # | Convert `Layout` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Pango.Objects.Layout Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Layout -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Layout) Source #
type ParentTypes Layout Source # |
Instance details Defined in GI.Pango.Objects.Layout type ParentTypes Layout = '[Object]

class (GObject o, IsDescendantOf Layout o) => IsLayout o Source #

Type class for types which can be safely cast to `Layout`, for instance with `toLayout`.

#### Instances

Instances details

(GObject o, IsDescendantOf Layout o) => IsLayout o Source # |
Instance details Defined in GI.Pango.Objects.Layout

toLayout :: (MonadIO m, IsLayout o) => o -> m Layout Source #

Cast to `Layout`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, contextChanged, copy, forceFloating, freezeNotify, getv, indexToLineX, indexToPos, isEllipsized, isFloating, isWrapped, moveCursorVisually, notify, notifyByPspec, ref, refSink, runDispose, serialize, stealData, stealQdata, thawNotify, unref, watchClosure, writeToFile, xyToIndex.

#### Getters

getAlignment, getAttributes, getAutoDir, getBaseline, getCaretPos, getCharacterCount, getContext, getCursorPos, getData, getDirection, getEllipsize, getExtents, getFontDescription, getHeight, getIndent, getIter, getJustify, getJustifyLastLine, getLine, getLineCount, getLineReadonly, getLineSpacing, getLines, getLinesReadonly, getLogAttrs, getLogAttrsReadonly, getPixelExtents, getPixelSize, getProperty, getQdata, getSerial, getSingleParagraphMode, getSize, getSpacing, getTabs, getText, getUnknownGlyphsCount, getWidth, getWrap.

#### Setters

setAlignment, setAttributes, setAutoDir, setData, setDataFull, setEllipsize, setFontDescription, setHeight, setIndent, setJustify, setJustifyLastLine, setLineSpacing, setMarkup, setMarkupWithAccel, setProperty, setSingleParagraphMode, setSpacing, setTabs, setText, setWidth, setWrap.

## contextChanged

layoutContextChanged Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m () |

Forces recomputation of any state in the `PangoLayout` that might depend on the layout's context.

This function should be called if you make changes to the context subsequent to creating the layout.

## copy

layoutCopy Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `src`: a `PangoLayout`
-> m Layout | Returns: the newly allocated `PangoLayout`

Creates a deep copy-by-value of the layout.

The attribute list, tab array, and text from the original layout are all copied by value.

## deserialize

layoutDeserialize Source #

Arguments

:: (HasCallStack, MonadIO m, IsContext a) |
=> a | `context`: a `PangoContext`
-> Bytes | `bytes`: the bytes containing the data
-> [LayoutDeserializeFlags] | `flags`: `PangoLayoutDeserializeFlags`
-> m (Maybe Layout) | Returns: a new `PangoLayout` (Can throw `GError`)

Loads data previously created via `layoutSerialize`.

For a discussion of the supported format, see that function.

Note: to verify that the returned layout is identical to the one that was serialized, you can compare `bytes` to the result of serializing the layout again.

Since: 1.50

## getAlignment

layoutGetAlignment Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Alignment | Returns: the alignment

Gets the alignment for the layout: how partial lines are positioned within the horizontal space available.

## getAttributes

layoutGetAttributes Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Maybe AttrList) | Returns: a `PangoAttrList`

Gets the attribute list for the layout, if any.

## getAutoDir

layoutGetAutoDir Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: `True` if the bidirectional base direction is computed from the layout's contents, `False` otherwise

Gets whether to calculate the base direction for the layout according to its contents.

See `layoutSetAutoDir`.

Since: 1.4

## getBaseline

layoutGetBaseline Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: baseline of first line, from top of `layout`

Gets the Y position of baseline of the first line in `layout`.

Since: 1.22

## getCaretPos

layoutGetCaretPos Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `index_`: the byte index of the cursor
-> m (Rectangle, Rectangle) |

Given an index within a layout, determines the positions that of the strong and weak cursors if the insertion point is at that index.

This is a variant of `layoutGetCursorPos` that applies font metric information about caret slope and offset to the positions it returns.

<picture> <source srcset="caret-metrics-dark.png" media="(prefers-color-scheme: dark)"> <img alt="Caret metrics" src="caret-metrics-light.png"> </picture>

Since: 1.50

## getCharacterCount

layoutGetCharacterCount Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: the number of Unicode characters in the text of `layout`

Returns the number of Unicode characters in the the text of `layout`.

Since: 1.30

## getContext

layoutGetContext Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Context | Returns: the `PangoContext` for the layout

Retrieves the `PangoContext` used for this layout.

## getCursorPos

layoutGetCursorPos Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `index_`: the byte index of the cursor
-> m (Rectangle, Rectangle) |

Given an index within a layout, determines the positions that of the strong and weak cursors if the insertion point is at that index.

The position of each cursor is stored as a zero-width rectangle with the height of the run extents.

<picture> <source srcset="cursor-positions-dark.png" media="(prefers-color-scheme: dark)"> <img alt="Cursor positions" src="cursor-positions-light.png"> </picture>

The strong cursor location is the location where characters of the directionality equal to the base direction of the layout are inserted. The weak cursor location is the location where characters of the directionality opposite to the base direction of the layout are inserted.

The following example shows text with both a strong and a weak cursor.

<picture> <source srcset="split-cursor-dark.png" media="(prefers-color-scheme: dark)"> <img alt="Strong and weak cursors" src="split-cursor-light.png"> </picture>

The strong cursor has a little arrow pointing to the right, the weak cursor to the left. Typing a 'c' in this situation will insert the character after the 'b', and typing another Hebrew character, like 'ג', will insert it at the end.

## getDirection

layoutGetDirection Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `index`: the byte index of the char
-> m Direction | Returns: the text direction at `index`

Gets the text direction at the given character position in `layout`.

Since: 1.46

## getEllipsize

layoutGetEllipsize Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m EllipsizeMode | Returns: the current ellipsization mode for `layout`

Gets the type of ellipsization being performed for `layout`.

See `layoutSetEllipsize`.

Use `layoutIsEllipsized` to query whether any paragraphs were actually ellipsized.

Since: 1.6

## getExtents

layoutGetExtents Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Rectangle, Rectangle) |

Computes the logical and ink extents of `layout`.

Logical extents are usually what you want for positioning things. Note that both extents may have non-zero x and y. You may want to use those to offset where you render the layout. Not doing that is a very typical bug that shows up as right-to-left layouts not being correctly positioned in a layout with a set width.

The extents are given in layout coordinates and in Pango units; layout coordinates begin at the top left corner of the layout.

## getFontDescription

layoutGetFontDescription Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Maybe FontDescription) | Returns: a pointer to the layout's font description, or `Nothing` if the font description from the layout's context is inherited.

Gets the font description for the layout, if any.

Since: 1.8

## getHeight

layoutGetHeight Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: the height, in Pango units if positive, or number of lines if negative.

Gets the height of layout used for ellipsization.

See `layoutSetHeight` for details.

Since: 1.20

## getIndent

layoutGetIndent Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: the indent in Pango units

Gets the paragraph indent width in Pango units.

A negative value indicates a hanging indentation.

## getIter

layoutGetIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m LayoutIter | Returns: the new `PangoLayoutIter`

Returns an iterator to iterate over the visual extents of the layout.

## getJustify

layoutGetJustify Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: the justify value

Gets whether each complete line should be stretched to fill the entire width of the layout.

## getJustifyLastLine

layoutGetJustifyLastLine Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: the justify value

Gets whether the last line should be stretched to fill the entire width of the layout.

Since: 1.50

## getLine

layoutGetLine Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `line`: the index of a line, which must be between 0 and `pango_layout_get_line_count(layout) - 1`, inclusive.
-> m (Maybe LayoutLine) | Returns: the requested `PangoLayoutLine`, or `Nothing` if the index is out of range. This layout line can be ref'ed and retained, but will become invalid if changes are made to the `PangoLayout`.

Retrieves a particular line from a `PangoLayout`.

Use the faster `layoutGetLineReadonly` if you do not plan to modify the contents of the line (glyphs, glyph widths, etc.).

## getLineCount

layoutGetLineCount Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: `PangoLayout`
-> m Int32 | Returns: the line count

Retrieves the count of lines for the `layout`.

## getLineReadonly

layoutGetLineReadonly Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `line`: the index of a line, which must be between 0 and `pango_layout_get_line_count(layout) - 1`, inclusive.
-> m (Maybe LayoutLine) | Returns: the requested `PangoLayoutLine`, or `Nothing` if the index is out of range. This layout line can be ref'ed and retained, but will become invalid if changes are made to the `PangoLayout`. No changes should be made to the line.

Retrieves a particular line from a `PangoLayout`.

This is a faster alternative to `layoutGetLine`, but the user is not expected to modify the contents of the line (glyphs, glyph widths, etc.).

Since: 1.16

## getLineSpacing

layoutGetLineSpacing Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Float |

Gets the line spacing factor of `layout`.

See `layoutSetLineSpacing`.

Since: 1.44

## getLines

layoutGetLines Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m [LayoutLine] | Returns: a `GSList` containing the lines in the layout. This points to internal data of the `PangoLayout` and must be used with care. It will become invalid on any change to the layout's text or properties.

Returns the lines of the `layout` as a list.

Use the faster `layoutGetLinesReadonly` if you do not plan to modify the contents of the lines (glyphs, glyph widths, etc.).

## getLinesReadonly

layoutGetLinesReadonly Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m [LayoutLine] | Returns: a `GSList` containing the lines in the layout. This points to internal data of the `PangoLayout` and must be used with care. It will become invalid on any change to the layout's text or properties. No changes should be made to the lines.

Returns the lines of the `layout` as a list.

This is a faster alternative to `layoutGetLines`, but the user is not expected to modify the contents of the lines (glyphs, glyph widths, etc.).

Since: 1.16

## getLogAttrs

layoutGetLogAttrs Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m [LogAttr] |

Retrieves an array of logical attributes for each character in the `layout`.

## getLogAttrsReadonly

layoutGetLogAttrsReadonly Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m [LogAttr] | Returns: an array of logical attributes

Retrieves an array of logical attributes for each character in the `layout`.

This is a faster alternative to `layoutGetLogAttrs`. The returned array is part of `layout` and must not be modified. Modifying the layout will invalidate the returned array.

The number of attributes returned in `nAttrs` will be one more than the total number of characters in the layout, since there need to be attributes corresponding to both the position before the first character and the position after the last character.

Since: 1.30

## getPixelExtents

layoutGetPixelExtents Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Rectangle, Rectangle) |

Computes the logical and ink extents of `layout` in device units.

This function just calls `layoutGetExtents` followed by two [func`extentsToPixels`] calls, rounding `inkRect` and `logicalRect` such that the rounded rectangles fully contain the unrounded one (that is, passes them as first argument to `extentsToPixels`).

## getPixelSize

layoutGetPixelSize Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Int32, Int32) |

Determines the logical width and height of a `PangoLayout` in device units.

`layoutGetSize` returns the width and height scaled by `SCALE`. This is simply a convenience function around `layoutGetPixelExtents`.

## getSerial

layoutGetSerial Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Word32 | Returns: The current serial number of `layout`.

Returns the current serial number of `layout`.

The serial number is initialized to an small number larger than zero when a new layout is created and is increased whenever the layout is changed using any of the setter functions, or the `PangoContext` it uses has changed. The serial may wrap, but will never have the value 0. Since it can wrap, never compare it with "less than", always use "not equals".

This can be used to automatically detect changes to a `PangoLayout`, and is useful for example to decide whether a layout needs redrawing. To force the serial to be increased, use `layoutContextChanged`.

Since: 1.32.4

## getSingleParagraphMode

layoutGetSingleParagraphMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: `True` if the layout does not break paragraphs at paragraph separator characters, `False` otherwise

Obtains whether `layout` is in single paragraph mode.

See `layoutSetSingleParagraphMode`.

## getSize

layoutGetSize Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Int32, Int32) |

Determines the logical width and height of a `PangoLayout` in Pango units.

This is simply a convenience function around `layoutGetExtents`.

## getSpacing

layoutGetSpacing Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: the spacing in Pango units

Gets the amount of spacing between the lines of the layout.

## getTabs

layoutGetTabs Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m (Maybe TabArray) | Returns: a copy of the tabs for this layout

Gets the current `PangoTabArray` used by this layout.

If no `PangoTabArray` has been set, then the default tabs are in use and `Nothing` is returned. Default tabs are every 8 spaces.

The return value should be freed with `tabArrayFree`.

## getText

layoutGetText Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Text | Returns: the text in the `layout`

Gets the text in the layout.

The returned text should not be freed or modified.

## getUnknownGlyphsCount

layoutGetUnknownGlyphsCount Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: The number of unknown glyphs in `layout`

Counts the number of unknown glyphs in `layout`.

This function can be used to determine if there are any fonts available to render all characters in a certain string, or when used in combination with `AttrTypeFallback`, to check if a certain font supports all the characters in the string.

Since: 1.16

## getWidth

layoutGetWidth Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Int32 | Returns: the width in Pango units, or -1 if no width set.

Gets the width to which the lines of the `PangoLayout` should wrap.

## getWrap

layoutGetWrap Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m WrapMode | Returns: active wrap mode.

Gets the wrap mode for the layout.

Use `layoutIsWrapped` to query whether any paragraphs were actually wrapped.

## indexToLineX

layoutIndexToLineX Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `index_`: the byte index of a grapheme within the layout
-> Bool | `trailing`: an integer indicating the edge of the grapheme to retrieve the position of. If > 0, the trailing edge of the grapheme, if 0, the leading of the grapheme
-> m (Int32, Int32) |

Converts from byte `index_` within the `layout` to line and X position.

The X position is measured from the left edge of the line.

## indexToPos

layoutIndexToPos Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `index_`: byte index within `layout`
-> m Rectangle |

Converts from an index within a `PangoLayout` to the onscreen position corresponding to the grapheme at that index.

The returns is represented as rectangle. Note that `pos->x` is always the leading edge of the grapheme and `pos->x + pos->width` the trailing edge of the grapheme. If the directionality of the grapheme is right-to-left, then `pos->width` will be negative.

## isEllipsized

layoutIsEllipsized Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: `True` if any paragraphs had to be ellipsized, `False` otherwise

Queries whether the layout had to ellipsize any paragraphs.

This returns `True` if the ellipsization mode for `layout` is not `EllipsizeModeNone`, a positive width is set on `layout`, and there are paragraphs exceeding that width that have to be ellipsized.

Since: 1.16

## isWrapped

layoutIsWrapped Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> m Bool | Returns: `True` if any paragraphs had to be wrapped, `False` otherwise

Queries whether the layout had to wrap any paragraphs.

This returns `True` if a positive width is set on `layout`, ellipsization mode of `layout` is set to `EllipsizeModeNone`, and there are paragraphs exceeding the layout width that have to be wrapped.

Since: 1.16

## moveCursorVisually

layoutMoveCursorVisually Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Bool | `strong`: whether the moving cursor is the strong cursor or the weak cursor. The strong cursor is the cursor corresponding to text insertion in the base direction for the layout.
-> Int32 | `oldIndex`: the byte index of the current cursor position
-> Int32 | `oldTrailing`: if 0, the cursor was at the leading edge of the grapheme indicated by `oldIndex`, if > 0, the cursor was at the trailing edge.
-> Int32 | `direction`: direction to move cursor. A negative value indicates motion to the left
-> m (Int32, Int32) |

Computes a new cursor position from an old position and a direction.

If `direction` is positive, then the new position will cause the strong or weak cursor to be displayed one position to right of where it was with the old cursor position. If `direction` is negative, it will be moved to the left.

In the presence of bidirectional text, the correspondence between logical and visual order will depend on the direction of the current run, and there may be jumps when the cursor is moved off of the end of a run.

Motion here is in cursor positions, not in characters, so a single call to this function may move the cursor over multiple characters when multiple characters combine to form a single grapheme.

## new

layoutNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsContext a) |
=> a | `context`: a `PangoContext`
-> m Layout | Returns: the newly allocated `PangoLayout`

Create a new `PangoLayout` object with attributes initialized to default values for a particular `PangoContext`.

## serialize

layoutSerialize Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> [LayoutSerializeFlags] | `flags`: `PangoLayoutSerializeFlags`
-> m Bytes | Returns: a `GBytes` containing the serialized form of `layout`

Serializes the `layout` for later deserialization via [func`pango`.Layout.deserialize].

There are no guarantees about the format of the output across different versions of Pango and [func`pango`.Layout.deserialize] will reject data that it cannot parse.

The intended use of this function is testing, benchmarking and debugging. The format is not meant as a permanent storage format.

Since: 1.50

## setAlignment

layoutSetAlignment Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Alignment | `alignment`: the alignment
-> m () |

Sets the alignment for the layout: how partial lines are positioned within the horizontal space available.

The default alignment is `AlignmentLeft`.

## setAttributes

layoutSetAttributes Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Maybe AttrList | `attrs`: a `PangoAttrList`
-> m () |

Sets the text attributes for a layout object.

References `attrs`, so the caller can unref its reference.

## setAutoDir

layoutSetAutoDir Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Bool | `autoDir`: if `True`, compute the bidirectional base direction from the layout's contents
-> m () |

Sets whether to calculate the base direction for the layout according to its contents.

When this flag is on (the default), then paragraphs in `layout` that begin with strong right-to-left characters (Arabic and Hebrew principally), will have right-to-left layout, paragraphs with letters from other scripts will have left-to-right layout. Paragraphs with only neutral characters get their direction from the surrounding paragraphs.

When `False`, the choice between left-to-right and right-to-left layout is done according to the base direction of the layout's `PangoContext`. (See `contextSetBaseDir`).

When the auto-computed direction of a paragraph differs from the base direction of the context, the interpretation of `AlignmentLeft` and `AlignmentRight` are swapped.

Since: 1.4

## setEllipsize

layoutSetEllipsize Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> EllipsizeMode | `ellipsize`: the new ellipsization mode for `layout`
-> m () |

Sets the type of ellipsization being performed for `layout`.

Depending on the ellipsization mode `ellipsize` text is removed from the start, middle, or end of text so they fit within the width and height of layout set with `layoutSetWidth` and `layoutSetHeight`.

If the layout contains characters such as newlines that force it to be layed out in multiple paragraphs, then whether each paragraph is ellipsized separately or the entire layout is ellipsized as a whole depends on the set height of the layout.

The default value is `EllipsizeModeNone`.

See `layoutSetHeight` for details.

Since: 1.6

## setFontDescription

layoutSetFontDescription Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Maybe FontDescription | `desc`: the new `PangoFontDescription` to unset the current font description
-> m () |

Sets the default font description for the layout.

If no font description is set on the layout, the font description from the layout's context is used.

## setHeight

layoutSetHeight Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`.
-> Int32 | `height`: the desired height of the layout in Pango units if positive, or desired number of lines if negative.
-> m () |

Sets the height to which the `PangoLayout` should be ellipsized at.

There are two different behaviors, based on whether `height` is positive or negative.

If `height` is positive, it will be the maximum height of the layout. Only lines would be shown that would fit, and if there is any text omitted, an ellipsis added. At least one line is included in each paragraph regardless of how small the height value is. A value of zero will render exactly one line for the entire layout.

If `height` is negative, it will be the (negative of) maximum number of lines per paragraph. That is, the total number of lines shown may well be more than this value if the layout contains multiple paragraphs of text. The default value of -1 means that the first line of each paragraph is ellipsized. This behavior may be changed in the future to act per layout instead of per paragraph. File a bug against pango at https://gitlab.gnome.org/gnome/pango if your code relies on this behavior.

Height setting only has effect if a positive width is set on `layout` and ellipsization mode of `layout` is not `EllipsizeModeNone`. The behavior is undefined if a height other than -1 is set and ellipsization mode is set to `EllipsizeModeNone`, and may change in the future.

Since: 1.20

## setIndent

layoutSetIndent Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `indent`: the amount by which to indent
-> m () |

Sets the width in Pango units to indent each paragraph.

A negative value of `indent` will produce a hanging indentation. That is, the first line will have the full width, and subsequent lines will be indented by the absolute value of `indent`.

The indent setting is ignored if layout alignment is set to `AlignmentCenter`.

The default value is 0.

## setJustify

layoutSetJustify Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Bool | `justify`: whether the lines in the layout should be justified
-> m () |

Sets whether each complete line should be stretched to fill the entire width of the layout.

Stretching is typically done by adding whitespace, but for some scripts (such as Arabic), the justification may be done in more complex ways, like extending the characters.

Note that this setting is not implemented and so is ignored in Pango older than 1.18.

Note that tabs and justification conflict with each other: Justification will move content away from its tab-aligned positions.

The default value is `False`.

Also see `layoutSetJustifyLastLine`.

## setJustifyLastLine

layoutSetJustifyLastLine Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Bool | `justify`: whether the last line in the layout should be justified
-> m () |

Sets whether the last line should be stretched to fill the entire width of the layout.

This only has an effect if `layoutSetJustify` has been called as well.

The default value is `False`.

Since: 1.50

## setLineSpacing

layoutSetLineSpacing Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Float | `factor`: the new line spacing factor
-> m () |

Sets a factor for line spacing.

Typical values are: 0, 1, 1.5, 2. The default values is 0.

If `factor` is non-zero, lines are placed so that

baseline2 = baseline1 + factor * height2

where height2 is the line height of the second line (as determined by the font(s)). In this case, the spacing set with `layoutSetSpacing` is ignored.

If `factor` is zero (the default), spacing is applied as before.

Note: for semantics that are closer to the CSS line-height property, see `attrLineHeightNew`.

Since: 1.44

## setMarkup

layoutSetMarkup Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Text | `markup`: marked-up text
-> Int32 | `length`: length of marked-up text in bytes, or -1 if `markup` is `NUL`-terminated
-> m () |

Sets the layout text and attribute list from marked-up text.

See Pango Markup).

Replaces the current text and attribute list.

This is the same as `layoutSetMarkupWithAccel`, but the markup text isn't scanned for accelerators.

## setMarkupWithAccel

layoutSetMarkupWithAccel Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Text | `markup`: marked-up text (see Pango Markup)
-> Int32 | `length`: length of marked-up text in bytes, or -1 if `markup` is `NUL`-terminated
-> Char | `accelMarker`: marker for accelerators in the text
-> m Char |

Sets the layout text and attribute list from marked-up text.

See Pango Markup).

Replaces the current text and attribute list.

If `accelMarker` is nonzero, the given character will mark the character following it as an accelerator. For example, `accelMarker` might be an ampersand or underscore. All characters marked as an accelerator will receive a `UnderlineLow` attribute, and the first character so marked will be returned in `accelChar`. Two `accelMarker` characters following each other produce a single literal `accelMarker` character.

## setSingleParagraphMode

layoutSetSingleParagraphMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Bool | `setting`: new setting
-> m () |

Sets the single paragraph mode of `layout`.

If `setting` is `True`, do not treat newlines and similar characters as paragraph separators; instead, keep all text in a single paragraph, and display a glyph for paragraph separator characters. Used when you want to allow editing of newlines on a single text line.

The default value is `False`.

## setSpacing

layoutSetSpacing Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `spacing`: the amount of spacing
-> m () |

Sets the amount of spacing in Pango units between the lines of the layout.

When placing lines with spacing, Pango arranges things so that

line2.top = line1.bottom + spacing

The default value is 0.

Note: Since 1.44, Pango is using the line height (as determined by the font) for placing lines when the line spacing factor is set to a non-zero value with `layoutSetLineSpacing`. In that case, the `spacing` set with this function is ignored.

Note: for semantics that are closer to the CSS line-height property, see `attrLineHeightNew`.

## setTabs

layoutSetTabs Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Maybe TabArray | `tabs`: a `PangoTabArray`
-> m () |

Sets the tabs to use for `layout`, overriding the default tabs.

`PangoLayout` will place content at the next tab position whenever it meets a Tab character (U+0009).

By default, tabs are every 8 spaces. If `tabs` is `Nothing`, the default tabs are reinstated. `tabs` is copied into the layout; you must free your copy of `tabs` yourself.

Note that tabs and justification conflict with each other: Justification will move content away from its tab-aligned positions. The same is true for alignments other than `AlignmentLeft`.

## setText

layoutSetText Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Text | `text`: the text
-> Int32 | `length`: maximum length of `text`, in bytes. -1 indicates that the string is nul-terminated and the length should be calculated. The text will also be truncated on encountering a nul-termination even when `length` is positive.
-> m () |

Sets the text of the layout.

This function validates `text` and renders invalid UTF-8 with a placeholder glyph.

Note that if you have used `layoutSetMarkup` or `layoutSetMarkupWithAccel` on `layout` before, you may want to call `layoutSetAttributes` to clear the attributes set on the layout from the markup as this function does not clear attributes.

## setWidth

layoutSetWidth Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`.
-> Int32 | `width`: the desired width in Pango units, or -1 to indicate that no wrapping or ellipsization should be performed.
-> m () |

Sets the width to which the lines of the `PangoLayout` should wrap or ellipsized.

The default value is -1: no width set.

## setWrap

layoutSetWrap Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> WrapMode | `wrap`: the wrap mode
-> m () |

Sets the wrap mode.

The wrap mode only has effect if a width is set on the layout with `layoutSetWidth`. To turn off wrapping, set the width to -1.

The default value is `WrapModeWord`.

## writeToFile

layoutWriteToFile Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> [LayoutSerializeFlags] | `flags`: `PangoLayoutSerializeFlags`
-> [Char] | `filename`: the file to save it to
-> m () | (Can throw `GError`)

A convenience method to serialize a layout to a file.

It is equivalent to calling `layoutSerialize` followed by `fileSetContents`.

See those two functions for details on the arguments.

It is mostly intended for use inside a debugger to quickly dump a layout to a file for later inspection.

Since: 1.50

## xyToIndex

layoutXyToIndex Source #

Arguments

:: (HasCallStack, MonadIO m, IsLayout a) |
=> a | `layout`: a `PangoLayout`
-> Int32 | `x`: the X offset (in Pango units) from the left edge of the layout
-> Int32 | `y`: the Y offset (in Pango units) from the top edge of the layout
-> m (Bool, Int32, Int32) | Returns: `True` if the coordinates were inside text, `False` otherwise

Converts from X and Y position within a layout to the byte index to the character at that logical position.

If the Y position is not inside the layout, the closest position is chosen (the position will be clamped inside the layout). If the X position is not within the layout, then the start or the end of the line is chosen as described for `layoutLineXToIndex`. If either the X or Y positions were not inside the layout, then the function returns `False`; on an exact hit, it returns `True`.